package eu.jonahbauer.chat.bot.test;

import eu.jonahbauer.chat.bot.api.ChatBot;
import eu.jonahbauer.chat.bot.config.BotConfig;
import eu.jonahbauer.chat.bot.impl.ChatBotFactory;
import org.jetbrains.annotations.NotNull;

import java.util.function.Supplier;

public final class ChatBotFactoryAccess {

    private ChatBotFactoryAccess() {}

    public static <T extends ChatBot> T create(@NotNull BotConfig config, @NotNull Supplier<T> supplier) {
        return ScopedValue.where(ChatBotFactory.BOT_CONFIG, config).get(supplier);
    }

    public static <T extends ChatBot> T create(@NotNull Supplier<T> supplier) {
        return create(BotConfig.EMPTY, supplier);
    }
}
