package eu.jonahbauer.chat.bot.database.impl;

import eu.jonahbauer.chat.bot.database.Entity;
import org.jetbrains.annotations.NotNull;

import java.sql.Connection;
import java.sql.SQLException;

public interface Updater<T extends Record & Entity> {
    @SuppressWarnings("unchecked")
    static <T extends Record & Entity> @NotNull Updater<T> get(@NotNull Class<T> type) {
        return (Updater<T>) UpdaterFactory.INSTANCE.get(type);
    }

    boolean update(@NotNull Connection connection, @NotNull T entity) throws SQLException;
}