package eu.jonahbauer.chat.bot.pizza.model;

import eu.jonahbauer.chat.bot.pizza.PizzaBotException;
import eu.jonahbauer.chat.bot.pizza.model.table.OrderItem;
import eu.jonahbauer.chat.bot.pizza.model.table.Pizza;
import eu.jonahbauer.chat.bot.pizza.model.table.User;
import org.jetbrains.annotations.NotNull;

import java.util.List;

public record OrderItemSummary(@NotNull OrderItem item, @NotNull Pizza pizza, @NotNull List<UserWithPayment> users) {
    public @NotNull OrderItemSummary checkUserAccess(@NotNull User user) {
        if (users.stream().noneMatch(u -> u.id() == user.id())) {
            throw new PizzaBotException("Du bist nicht berechtigt, diese Bestellung zu bearbeiten.");
        }
        return this;
    }
}
